#ifndef _SRAM_H
#define _SRAM_H



/* header files we depend upon
 */
#include "../types/types.h"
#include "../apptel/fpga.h"



/* errors
 */
#define ERROR_SRAM_NOT_INITIALIZED      1
#define ERROR_SRAM_INVALID_ADDRESS      2
#define ERROR_SRAM_CYCLE_TIMEOUT        3
#define ERROR_SRAM_MISSING_ARGS         4       // used by callers but not me
#define ERROR_SRAM_CANNOT_ALLOC         5       // used by callers but not me



/* function prototypes
 */
#ifdef __cplusplus
extern "C" {
#endif

void sram_init_stats( void );
void sram_print_stats( void );
int sram_read_or_write( RxFpga_registers *rx_fpga, Bit32 address, int want_write, Bit32 *data0 );

#ifdef __cplusplus
}
#endif



#endif  /* not included yet */
