/* pkt_test.c - a minimal test program for the pkt driver interafce */

#define far_malloc malloc
#define far
#define huge

#define noTEST_IP

struct pkt {
   unsigned int p_len;
   unsigned char hdr[14];
   };

/* Declared in wattcp\src\pcpkt.c .. */

void pkt_rcv_call2(unsigned int handle, unsigned int len,
   unsigned char far *buff);

extern char au_monitor;  /* 1 to enable monitoring */

extern unsigned char eth_addr[6];
extern unsigned long npackets,nbytes;

#define MAXPKTLEN  1526

struct pkt far *pkts;

unsigned short
   maxpkt,  /* Must be a power of 2 */
   pktmask,   /* maxpkt-1 */
   prcv,   /* Index of next pkt to be received (i.e. next empty pkt) */
   pproc;  /* Index of next pkt to be processed (i.e. next full pkt) */

#ifndef NULL
#define NULL  0
#endif

#include <dos.h>
#include <alloc.h>
#include <ctype.h>
#include <errno.h>

#include <sys/types.h>
#include <stdio.h>
#include "..\wattcp\tcp.h"

udp_Socket udpsock;
static udp_Socket *s;
int status;  /* For socket */
word _pktdevclass = 1;      /* Ethernet = 1, SLIP = 6 */

/* forward declarations
 */
void receive( void );

void pkt_rcv_call2(unsigned int handle,
   unsigned int len, unsigned char far *buff)
{
   struct pkt huge *pp;
   short j;

#ifdef TEST_IP
   if (buff[0] == 0xFF && buff[1] == 0xFF && buff[2] == 0xFF &&
         buff[3] == 0xFF && buff[4] == 0xFF && buff[5] == 0xFF) {
      if (buff[12] == 0x08 &&
            (buff[13] == 0x00 || buff[13] == 0x06 )) {  /* IP or ARP */
         buff[-2] = 1;  /* Ready for tcp/ip */
         }
      else buff[-2] = 0;  /* Not for us; free the buffer */
      }
   else if (buff[5] == eth_addr[5] && buff[4] == eth_addr[4] &&
         buff[3] == eth_addr[3] && buff[2] == eth_addr[2] &&
         buff[1] == eth_addr[1] && buff[0] == eth_addr[0]) {
      if (buff[12] == 0x08 &&
            (buff[13] == 0x00 || buff[13] == 0x06 )) {  /* IP or ARP */
         buff[-2] = 1;  /* Ready for tcp/ip */
         }
      else buff[-2] = 0;  /* Not for us; free the buffer */
      }
   else buff[-2] = 0;  /* Not for us; free the buffer */
#else
   buff[-2] = 0;  /* Ignoring our packets; free the WATTCP buffer */
#endif

   if(((pproc - prcv) & pktmask) == 1) {  /* No pkts free, ignore the data */
      }
   else {
      pp = &pkts[prcv];
      pp->p_len = len;
      for (j = 0; j != 14; ++j) pp->hdr[j] = buff[j];
      prcv = (prcv+1) & pktmask;
      }
   }

int main(int argc, char *argv[])
{
   int arg, c;
   char cbuf[20], *ap;

   for (c = 0, arg = 1; arg < argc; ++arg) {
      if (argv[arg][0] == '-') {
         ap = argv[arg]+2;
         switch (argv[arg][1]) {
#ifdef TEST_IP
         case 'd':
            snmp_dump_packet++;
            break;
#endif
#ifdef EXAMPLE
         case 'f':
            if (*ap == NULL) ap = argv[++arg];
            mxflowsp1 = atoi(ap)+1;
            break;
         case 'w':
            if (*ap == NULL) ap = argv[++arg];
            communities[2] = ap;  /* -w to set write community */
            break;
#endif
         default:
            printf("Invalid option: -%c\n", argv[arg][1]);
            exit(0);
            }
         }
      }

   maxpkt = 1024;
   pktmask = maxpkt-1;
   pkts = (struct pkt far *)farmalloc((maxpkt+1) * sizeof(struct pkt));
   pproc = prcv = 0;
   au_monitor = 1;
#ifdef TEST_IP
   sock_init();  /* Initialise full TCP/IP stack */
#else
   pkt_init();  /* Initialise just packet driver */
   pkt_buf_wipe();
#endif

#ifdef TEST_IP
   s = &udpsock;  /* myport        hisadr hisport */
   if (!udp_open( s, SNMP_PORT,  0, 0,        0 )) {
      puts("udp_open failed!\n");
      exit(1);
      }
#endif

   receive();
   }

void receive( void )
{
   unsigned short k, n, npkts = 0;
   long tot = set_timeout(1);
   struct pkt huge *pp;
   unsigned char ch;

   pproc = prcv;  /* Discard packets collected during initialisation */
   for (;;) {
#ifdef TEST_IP
      sock_tick(s, &status);  /* Keep WATTCP alive */
      if ((n = sock_dataready(s)) != 0) {
         snmp_read(n);
         sock_close(s);
         if (!udp_open( s, SNMP_PORT,  0, 0,   0 )) {
            puts("udp_open failed!\n");
            exit(1);
            }
         }
#endif

      k = (prcv-pproc) & pktmask;
      if (k != 0) {  /* We have received some packets */
         for (; k != 0; --k) {
            pp = &pkts[pproc];
            printf("%5u: %5u ", ++npkts,pp->p_len);
            for (n = 0; n != 6; ++n) printf(" %02X", pp->hdr[n]);
            printf(" ");
            for (n = 6; n != 12; ++n) printf(" %02X", pp->hdr[n]);
            printf("  %02x%02X\n", pp->hdr[12],pp->hdr[13]);
            pproc = (pproc+1) & pktmask;
            }
         }

      if (chk_timeout(tot)) {
         tot = set_timeout(1);  /* 1 second */
         if (kbhit()) {
            if ((ch = getch()) == 27) {  /* ESC */
               printf("\nShutting down\n");
#ifdef TEST_IP
               // no effort required to stop whole TCP/IP stack
               // because it has an atexit() handler
               //
#else
               // shut down access to packet driver
               //
               pkt_release();
#endif
               exit(0);
               }
            }
         }
      }

#ifdef TEST_IP
sock_err:
   switch (status) {
   case 1 : /* foreign host closed */
      exit(0);
   case -1: /* timeout */
      printf("\nConnection timed out!");
      exit(1);
   default: printf("Aborting");
      exit(1);
      }
#endif
   }

#ifdef TEST_IP
void snmp_read(length)
int length;
{
   int out_length;
   unsigned char packet[1500];
   int count;

   sock_read(s, packet,length);
   if (snmp_dump_packet) {
      printf("received %d bytes:\n", length);
      for (count = 0; count < length; count++) {
         printf("%02X ", packet[count]);
         if ((count % 16) == 15) printf("\n");
         }
      printf("\n\n");
      }
   sock_write(s, packet,length);  /* Just echo the SNMP packet */
   }
#endif

void au_send_mon(int length, unsigned char far *buffer)
{  return;  }  /* Default version, never used */
