/* 1452, Tue 6 Oct 98 */

#define WATTCPH

#ifdef __cplusplus
extern "C" {
#endif

#define IP_TYPE  0x0008  /* Intelled */

/*
#define DEBUG
*/
/*
#define MoveW(a,b,c) movmem(a,b,c)
#define busyouta(c) (putch(c))
*/


#include <stdio.h>
#include "..\wattcp\elib.h"

#define set_mstimeout(x) (set_timeout(0)+ (x / 55))

#define MAX_GATE_DATA 12
#define MAX_NAMESERVERS 10
#define MAX_COOKIES 10
#define MAX_STRING 50   /* Most strings are limited */

#define SAFETYTCP  0x538f25a3L
#define SAFETYUDP  0x3e45e154L
#define TRUE       1
#define true       TRUE
#define FALSE      0
#define false      FALSE

/*
 * Constants and structures defined by the internet system,
 * Per RFC 790, September 1981, taken from the BSD file netinet/in.h.
 */

/*
 * Protocols
 */
#define IPPROTO_IP          0  /* Dummy for IP */
#define IPPROTO_ICMP        1  /* Control Message Protocol */
#define IPPROTO_GGP         2  /* Gateway^2 (deprecated) */
#define IPPROTO_IP_IN_IP    4  /* Used for tunneling */
#define IPPROTO_TCP         6  /* tcp */
#define IPPROTO_PUP        12  /* pup */
#define IPPROTO_UDP        17  /* User Datagram Protocol */
#define IPPROTO_IDP        22  /* XNS idp */
#define IPPROTO_ND         77  /* UNOFFICIAL net disk proto */

#define IPPROTO_RAW       255  /* Raw IP packet */
#define IPPROTO_MAX       256




#define TCP_MODE_BINARY   0    /* Default mode */
#define TCP_MODE_ASCII    1
#define UDP_MODE_CHK      0    /* Default to having checksums */
#define UDP_MODE_NOCHK    2    /* Turn off checksums */
#define TCP_MODE_NAGLE    0    /* Nagle algorithm */
#define TCP_MODE_NONAGLE  4

extern void sock_init(void);

typedef unsigned long longword;  /* 32 bits */
typedef unsigned short word;     /* 16 bits */
typedef unsigned char byte;      /*  8 bits */
typedef byte eth_address[6];

#define TICKS_SEC  18

#define ETH_MTU     1514
#define ETH_MSS     (ETH_MTU-sizeof(eth_Header)-sizeof(in_Header)-sizeof(tcp_Header))
#define ETH_MAXUDP  (ETH_MTU-sizeof(eth_Header)-sizeof(in_Header)-sizeof(udp_Header))

/* Packet buffers and their queues .. */

#ifndef MAX_SUBID  /* Declared in snmplib\asn1.h */
struct c64 {
   unsigned long high;
   unsigned long low;
   };
typedef struct c64 counter64;
#endif

/* IP packet queue structures */
struct pbuf {
   struct pbuf *next;
   Bit8 state;
/*      0        buffer available
 *      1        buffer being filled by ethernet driver
 *      2        buffer filled
 *      3        buffer in use by application */
   Bit8 unused;
   Bit32 seq;  /* For ordered queues */
   union {
      union {  /* NeTraMet packet arrival time */
         double d;
         counter64 c;
         } arrival_time;
      struct {  /* TCP packet info */
         int offset;
         int len;
         } p;
      } d;
   Bit8 data[ETH_MTU];
   };
#define BUF_HDR_LEN  (sizeof(struct pbuf) - ETH_MTU)

struct bufq {
   struct pbuf *head, *tail;
   int len;
   };

extern struct bufq freeq;  /* Declared (and initialised) in pcpkt.c */
extern struct bufq readyq;

void enqueue(struct bufq *bq, struct pbuf *pb);  /* Function prototypes */
void seq_enqueue(struct bufq *bq, struct pbuf *pb);
struct pbuf *dequeue(struct bufq *bq);

/* TCP unacknowledged (out of order) segment queue */
struct pseg {
   struct pseg *next;
   Bit32 seq;
   Bit32 len;
   };

struct segq {
   struct pseg *head, *tail;
   longword len;
   };

extern struct pseg *misordered_all;
extern struct segq misordered_free;

void seg_enqueue_merge( struct segq *bq, struct pseg *np );
void seg_enqueue_tail(struct segq *bq, struct pseg *np);
void seg_enqueue_head(struct segq *bq, struct pseg *np);
struct pseg *seg_dequeue_head(struct segq *bq);

#define checksum(p, len) inchksum(p, len)


#define PD_ETHER  1
#define PD_SLIP   6

extern word sock_inactive;     /* In pcbootp.c */
extern word _pktdevclass;
extern word _mss;
extern word _bootptimeout;     /* In pcbootp.c */
extern longword _bootphost;    /* In pcbootp.c */
extern word _bootpon;

/* The Ethernet header */
typedef struct {
   eth_address destination;
   eth_address source;
   word        type;
   } eth_Header;

/* The Internet Header: */
typedef struct {
   unsigned hdrlen : 4;
   unsigned ver    : 4;
   byte     tos;
   word     length;
   word     identification;
   unsigned frags : 3;
   unsigned fo    : 13;
   byte     ttl;
   byte     proto;
   word     checksum;
   longword source;
   longword destination;
   } in_Header;


#define in_GetVersion(ip) ( (ip)->ver )
#define in_GetHdrlen(ip)  ( (ip)->hdrlen )  /* 32 bit word size */
#define in_GetHdrlenBytes(ip)  ( in_GetHdrlen(ip) << 2 ) /* 8 bit byte size */
#define in_GetTos(ip)      ( (ip)->tos)

#define in_GetTTL(ip)      ((ip)->ttl)
#define in_GetProtocol(ip) ((ip)->proto )

#define in_DefaultTTL       254

typedef struct {
   word srcPort;
   word dstPort;
   word length;
   word checksum;
   } udp_Header;

#define UDP_LENGTH ( sizeof( udp_Header ))

typedef struct {
   word     srcPort;
   word     dstPort;
   longword seqnum;
   longword acknum;
   word     flags;
   word     window;
   word     checksum;
   word     urgentPointer;
   } tcp_Header;

#define tcp_FlagFIN   0x0001
#define tcp_FlagSYN   0x0002
#define tcp_FlagRST   0x0004
#define tcp_FlagPUSH  0x0008
#define tcp_FlagACK   0x0010
#define tcp_FlagURG   0x0020
#define tcp_FlagDO    0xF000
#define tcp_GetDataOffset(tp) (ntohs((tp)->flags) >> 12)
#define tcp_MaxWinShift   14    /* maximum window shift */

/* The TCP/UDP Pseudo Header */
typedef struct {
   longword src;
   longword dst;
   byte     mbz;
   byte     protocol;
   word     length;
   word     checksum;
   } tcp_PseudoHeader;

/*
 * TCP states, from tcp manual.
 */
#define tcp_StateOPEN      0  /* (not in spec) opened but neither passive not active open yet */
#define tcp_StateLISTEN    1  /* listening for connection */
#define tcp_StateSYNSENT   2  /* Syn sent, active open */
#define tcp_StateSYNREC    3  /* Syn received, synack+syn sent. */
#define tcp_StateESTAB     4  /* Established */
#define tcp_StateESTCL     5  /* (not in spec) Established, got close, will FIN when data drained */
#define tcp_StateFINWT1    6  /* Sent FIN */
#define tcp_StateFINWT2    7  /* Sent FIN, received FINACK */
#define tcp_StateCLOSWT    8  /* Received FIN waiting for close */
#define tcp_StateCLOSWTCL  9  /* (not in spec) Received FIN, got close, will FIN when data drained */
#define tcp_StateCLOSING  10  /* Sent FIN, received FIN (waiting for FINACK) */
#define tcp_StateLASTACK  11  /* Fin received, finack+fin sent */
#define tcp_StateTIMEWT   12  /* Dally after sending final FINACK */
#define tcp_StateCLOSED   13  /* (not in spec) Finack received */





#define tcp_MaxBufSize   8192        /* Number of bytes in default input and output buffers */
#define udp_MaxBufSize   ETH_MAXUDP  /* Number of bytes in default input buffer */


typedef int (*waitprocref)(void *tcp_or_udp_socket);
typedef int (*dataprocref)(void *tcp_or_udp_socket,
   byte *data, longword len, tcp_PseudoHeader *ph, void *tcp_or_udp_header);


/*
 * UDP socket definition
 */
typedef struct _udp_socket {
   struct _udp_socket *next;
   word        ip_type;        /* Always set to IPPROTO_UDP */
   word        sock_mode;      /* A logical OR of bits */
   char       *err_msg;        /* Null when all is ok */
   char       *usr_name;
   void      (*usr_yield)(void);
   byte        ttl;
   byte        tos;            /* ignored by UDP */
   eth_address hisethaddr;     /* Peer's ethernet address */
   longword    usertimer;      /* ip_timer_set, ip_timer_timeout */
   dataprocref rdataHandler;   /* Called with incoming data */
   longword    hisaddr;        /* Peer's internet address */
   word        hisport;        /* Peer's UDP port */
   word        myport;
   longword    myaddr;
   longword    tunneladdr;     /* 0.0.0.0 means no tunneling */

   longword    rdataoffset;    /* Because buffer is circular */
   longword    rdatalen;
   longword    maxrdatalen;
   byte       *rdata;
   byte        rddata[udp_MaxBufSize+1];  /* Default buffer for rx data */
   byte        pad1[3];

   longword    safetysig;
   } udp_Socket;

/* CAUTION: Be VERY careful when changing the udp_Socket
      and/or tcp_Socket declarations.  Remember that
      => => they must match exactly up to the start of rddata[] <= <=
      => => their sizes also appear in tcp.h <= <=
      If you change them here, you must reflect the change into tcp.h!

      To find the sizes for udp_Socket and tcp_Socket, make the
         wattcp object files, then make ..\watapps\tcpinfo.exe.
      tcpinfo all   tells you the socket sizes
   Nevil, Wed 29 Jan 98 */

/* However, you can avoid recompiling every client of this
   library every time the layout of these 2 structures changes,
   since they get their size but not the layout from TCP.H,
   by leaving some slop in the sizes in TCP.H
   Joel, 27 May 1998 */

/* reorganized to align all 4-byte fields on a 4-byte boundary,
   all 2-byte fields on a 2-byte boundary
   Joel 27 May 1998 */

/* got rid of tcp_Socket->sock_delay (not to be confused with
   global scalar sock_delay) since neither clients nor library
   were using it for anything               Joel 27 May 1998 */


/*
 * TCP Socket definition
 */
typedef struct _tcp_socket {
   struct _tcp_socket *next;
   word        ip_type;        /* Always set to IPPROTO_TCP */
   word        sock_mode;      /* A logical OR of bits */
   char       *err_msg;
   char       *usr_name;
   void      (*usr_yield)( void );
   byte        ttl;
   byte        tos;            /* priority */
   eth_address hisethaddr;     /* Ethernet address of peer */
   longword    usertimer;      /* ip_timer_set, ip_timer_timeout */
   dataprocref rdataHandler;   /* Called with incoming data */
   longword    hisaddr;        /* Internet address of peer */
   word        hisport;        /* TCP ports for this connection */
   word        myport;
   longword    myaddr;
   longword    tunneladdr;     /* 0.0.0.0 means no tunneling */

   longword    rdataoffset;    /* Because buffer is circular */
   longword    rdatalen;
   longword    maxrdatalen;
   byte       *rdata;
   byte        rddata[tcp_MaxBufSize+1];  /* Default buffer for rx data */
   byte        pad1[3];

    /* --- All fields up to here had to match udp_Socket --- */

   longword    acknum;         /* Highest seq number we sent an ack for */
   longword    seqnum;         /* Highest seq number we got an ack for */

                               /* these are useless if >4GB sent or received */
   longword    dbg_rx_seqbase; /* first sequence number we received */
   longword    dbg_tx_seqbase; /* first sequence number we sent */

   byte        rx_wscale;      /* Other guy's window scaling shift count (-1 if no SYN RX yet) */
   byte        tx_wscale;      /* Our window scaling shift count */
   word        oldwindow;      /* Last window we sent, for comparison */
   longword    window;         /* Other guy's window, already scaled */

   word        state;          /* Connection's TCP state */
   word        flags;          /* TCP flags word for last packet sent */
   long        abort_timeout;  /* in seconds, used when opening and closing */

   longword    unacked;        /* Offset into buffer to send next */
   longword    maxunacked;     /* Nbr of sent but unacked bytes */

   byte        soon_req;       /* sendsoon() called recently ++*/
   byte        data_pkts;      /* Data packets received since last ack ++*/

   word        ssthresh;       /* Congestion avoidance ++*/
   word        cwnd;           /* ==*/
   word        wwnd;           /* counts up to cwnd during CA */
   byte        wwnd2;          /* counts up to 8 during CA */
   byte        dup_ack;        /* Nbr of duplicate ACKs seen ++*/

   byte        pad2;

   byte        AD_ok;          /* OK to compute sA, sD from rtt ++*/
   word        sA;             /* VJ's alg, scaled average ==*/
   word        sD;             /* VJ's alg, scaled deviation ==*/
   word        rto;            /* VJ's retransmission timeout, in ticks ==*/

   word        mss;            /* default or negotiated maximum segment size */

   longword    tx_time;        /* Packet transmit time (ticks) ==*/
   longword    tx_seq;         /* Seq expected for timed packet's ack ++*/

   longword    retrans_timeout;   /* when should we retransmit SYN or data? */

   struct segq misordered;     /* Queue of unacked line-segments of RX buffer,
                                     in sequence number order ++*/

   longword    inactive_to;    /* For the inactive flag */

   longword    sdataoffset;    /* Because buffer is circular */
   longword    sdatalen;       /* Nbr of bytes to send */
   longword    maxsdatalen;
   byte       *sdata;
   byte        sddata[tcp_MaxBufSize+1];  /* Default buffer for data to send */
   byte        pad3[3];

   longword    safetysig;
   } tcp_Socket;

/* sock_type used for socket io */
typedef union {
   udp_Socket udp;
   tcp_Socket tcp;
   FILE       file;
   } sock_type;

/* Deals with wrapping offsets into circular buffers */
#define wrap(pos,max) (pos<max ? pos : pos-max)

/* Similar to UNIX */
typedef struct sockaddr {
   word     s_type;
   word     s_port;
   longword s_ip;
   byte     s_spares[6];  /* Unused in TCP realm */
   };

#define sockaddr_in sockaddr

extern longword my_ip_addr;
extern eth_address _eth_addr;
extern eth_address _eth_brdcast;
extern longword sin_mask;
extern word sock_delay;

/*
 * ARP definitions
 */
#define arp_TypeEther  0x100   /* ARP type of Ethernet address */

/* ARP op codes */
#define ARP_REQUEST 0x0100
#define ARP_REPLY   0x0200

/*
 * ARP header
 */
typedef struct {
   word        hwType;
   word        protType;
   word        hwProtAddrLen;  /* H/w and prot addr len */
   word        opcode;
   eth_address srcEthAddr;
   longword    srcIPAddr;
   eth_address dstEthAddr;
   longword    dstIPAddr;
   } arp_Header;

 /* Ethernet interface .. */

extern void  _eth_init(void);
extern byte *_eth_formatpacket(void *eth_dest, word eth_type);
extern int   _eth_send(word len);
extern void  _eth_free(void *buf);
extern byte *_eth_arrived(word *type_ptr);
extern void  _eth_release(void);

extern void *_eth_hardware(byte *p);

extern void ip_timer_init(udp_Socket *s, int seconds);
extern int  ip_timer_expired(udp_Socket *s);

/*
 * Socket macros
 */

/*
 * sock_wait_established()
 *      - Waits then aborts if timeout on s connection
 * sock_wait_input()
 *      - Waits for received input on s
 *      - May not be valid input for sock_gets... check returned length
 * sock_tick()
 *      - Do tick and jump on abort
 * sock_wait_closed();
 *      - Discards all received data
 *
 * All jump to sock_err with contents of *statusptr set to
 *       1 on closed
 *      -1 on timeout
 *
 */

extern int tcp_tick(sock_type *s);
extern _ip_delay0(sock_type *s, int timeoutseconds, waitprocref fn, int *statusptr);
extern _ip_delay1(sock_type *s, int timeoutseconds, waitprocref fn, int *statusptr);
extern _ip_delay2(sock_type *s, int timeoutseconds, waitprocref fn, int *statusptr);

#define sock_wait_established(s, seconds, fn, statusptr) \
    if (_ip_delay0(s, seconds, fn, statusptr)) goto sock_err;
#define sock_wait_input(s, seconds, fn , statusptr) \
    if (_ip_delay1(s, seconds, fn, statusptr)) goto sock_err;
#define sock_tick(s, statusptr) \
    if (!tcp_tick(s)) { *statusptr = 1 ; goto sock_err; }
#define sock_wait_closed(s, seconds, fn, statusptr)\
    if (_ip_delay2(s, seconds, fn, statusptr)) goto sock_err;

// in UDP_NDS.C
extern longword resolve(char *asciiname);  /* In udp_nds.c */

extern int _last_cookie;
extern longword _cookie[MAX_COOKIES];

extern char *def_domain;
extern longword def_nameservers[MAX_NAMESERVERS];
extern int _last_nameserver;
extern char *_hostname;

extern word isaddr(char *string);
extern longword aton(char *string);

extern void _arp_register(longword use, longword instead_of);
extern int _arp_resolve(longword ina, eth_address *ethap, int nowait);

extern longword pkt_flat2phys(void *pointer);
extern void * _pkt_eth_init(void);
extern void pkt_release(void);
extern int pkt_send(char *buffer, int length);
extern void pkt_buf_wipe(void);
extern void pkt_buf_release(char *ptr);
extern void * pkt_received(struct bufq *bq);

extern void _add_server(int *counter, int max, longword *array, longword value);
extern word debug_on;
extern char *rip(char *s);
extern _chk_socket(tcp_Socket *s);
extern char *inet_ntoa(char *s, longword x);
extern void psocket(tcp_Socket *s);
extern longword inet_addr(char *s);
extern char *sockerr(tcp_Socket *s);
extern char *sockstate(tcp_Socket *s);
extern getpeername(tcp_Socket *s, void *dest, int *len);
extern getsockname( tcp_Socket *s, void *dest, int *len);
extern longword gethostid(void);
extern longword sethostid(longword ip);
extern char *getdomainname(char *name, int length);
extern char *setdomainname(char *string);

/* Used by pcarp.c */
extern void _udp_cancel(in_Header *ip);
extern void _tcp_cancel(in_Header *ip, int code, char *msg, longword dummyip);

/* Used by sock_prn.c */
extern longword sock_puts(sock_type *s, byte *dp);
extern longword sock_gets(sock_type *, byte *, longword);
extern longword sock_dataready(sock_type *s);

/* Used by sock_ini.c */
extern void tcp_shutdown(void);
extern void tcp_init(void);
extern void tcp_cbrk(int mode);
extern tcp_config(char *path);
extern int _dobootp(void);

/* Used by pcconfig.c */
extern void _arp_add_gateway(char *data , longword ip);

/* Used by pctcp.c defined in pcarp.c */
extern int _arp_handler(arp_Header *in);

extern void * _tcp_lookup(longword hisip, word hisport, word myport);
extern int addwattcpd(void (*p)());
extern int delwattcpd(void (*p)());
extern word sock_mode(sock_type *, word);
extern void sock_abort(sock_type *);
extern longword sock_fastwrite(sock_type *, byte *, longword);
extern longword sock_write(sock_type *, byte *, longword);
extern longword sock_read(sock_type *, byte *, longword);
extern longword sock_fastread(sock_type *, byte *, longword);

extern int udp_open(udp_Socket *s, word lport, longword ina, word port, dataprocref datahandler);
extern int tcp_open(tcp_Socket *s, word lport);
extern int tcp_listen(tcp_Socket *s, longword ina, word port, dataprocref datahandler, word timeout);
extern int tcp_connect(tcp_Socket *s, longword ina, word port, dataprocref datahandler);
extern void sock_close(sock_type *);

extern longword sock_set_rx_buf(tcp_Socket *s, byte *dp, longword len );
extern longword sock_set_tx_buf(tcp_Socket *s, byte *dp, longword len );
#ifdef __cplusplus
}

/* These functions only work in C++ code
 *    because they use C++ datatypes
 */
extern int _ping(longword host, word identifier, word sequence);
extern int _chk_ping(longword host, word *identifier, word *sequence, PentiumClock *delta_when);
#endif

